package virusrecords;


/**
 * Title: Event Class
 * Description: The Event class holds the virus event information
 * Copyright: GPL
 * Company: University of Colorado at Colorado Springs: CS522 CVI/PRS Project
 * @author : Benjamin A. Abernathy
 * @version 1.0
 */

public class Event {

  String VirusName = new String();
  String VirusFileName = new String();
  String Author = new String();
  String Date = new String();
  String Description = new String();

  public Event() {
    VirusName = "Bilbo Baggins";
    VirusFileName = "//dev//null//baggins";
    Author = "Lord Nikon";
    Date = "01//21//1981";
    Description = "Your mother has fluffly bunny feet.";
  }

  public Event( String NewName, String NewFileName, String NewAuthor,
                        String NewDate, String NewDescription ) {
    VirusName = NewName;
    VirusFileName = NewFileName;
    Author = NewAuthor;
    Date = NewDate;
    Description = NewDescription;
 }

  //Accessor Methods

  public void setVirusName( String NewName ) {
    VirusName = NewName;
  }

  public void setVirusFileName( String NewFileName ) {
    VirusFileName = NewFileName;
  }

  public void setAuthor( String NewAuthor ) {
    Author = NewAuthor;
  }

  public void setDate( String NewDate ) {
    Date = NewDate;
  }

  public void setDescription( String NewDescription ) {
   Description = NewDescription;
  }

  public void setEvent( String NewName, String NewFileName, String NewAuthor,
                        String NewDate, String NewDescription ) {
    VirusName = NewName;
    VirusFileName = NewFileName;
    Author = NewAuthor;
    Date = NewDate;
    Description = NewDescription;
 }

 public String getVirusName() {
  return( VirusName );
 }

 public String getVirusFileName() {
  return( VirusFileName );
 }

 public String getAuthor() {
  return( Author );
 }

 public String getDate() {
  return( Date );
 }

 public String getDescription() {
  return( Description );
 }

}