package virusrecords;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import com.borland.jbcl.layout.*;
import javax.swing.border.*;
import java.util.*;


public class VFrame extends JFrame {
  VirusDatabase VDataBase;
  int selectIndex = 0;

  DefaultListModel listModel = new DefaultListModel();
  JPanel contentPane;
  XYLayout xYLayout2 = new XYLayout();
  JPanel jPanel1 = new JPanel();

  JList RecordList = new JList(listModel);

  JScrollPane jScrollPane1 = new JScrollPane(RecordList);

  XYLayout xYLayout1 = new XYLayout();
  JLabel listLabel = new JLabel();
  JPanel jPanel2 = new JPanel();
  XYLayout xYLayout3 = new XYLayout();
  JPanel jPanel3 = new JPanel();
  XYLayout xYLayout4 = new XYLayout();
  JScrollPane jScrollPane2 = new JScrollPane();
  JTextPane DescriptionTextPane = new JTextPane();
  JLabel DescriptionLabel = new JLabel();
  JLabel RecordInfoLabel = new JLabel();
  TitledBorder titledBorder1;
  JTextField AuthorTextField = new JTextField();
  JLabel AuthorLabel = new JLabel();
  JLabel DateLabel = new JLabel();
  JTextField DateTextField = new JTextField();
  JLabel NameLabel = new JLabel();
  JTextField NameTextField = new JTextField();
  JLabel FileNameLabel = new JLabel();
  JTextField FileNameTextField = new JTextField();
  JLabel jLabel1 = new JLabel();
  JButton AddButton = new JButton();
  JButton RemoveButton = new JButton();
  JLabel AddLabel = new JLabel();
  JLabel RemoveLabel = new JLabel();

  /**Construct the frame*/
  public VFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);


    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }


  }


  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(Frame1.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    titledBorder1 = new TitledBorder("");
    contentPane.setLayout(xYLayout2);
    this.setSize(new Dimension(716, 712));
    this.setTitle("Virus Database");
    jPanel1.setLayout(xYLayout1);
    listLabel.setFont(new java.awt.Font("Serif", 3, 17));
    listLabel.setHorizontalTextPosition(SwingConstants.CENTER);
    listLabel.setLabelFor(RecordList);
    listLabel.setText("Current Viruses on Record");
    jPanel1.setBorder(BorderFactory.createEtchedBorder());
    jPanel2.setBorder(BorderFactory.createEtchedBorder());
    jPanel2.setLayout(xYLayout3);
    jPanel3.setLayout(xYLayout4);
    jScrollPane2.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    jScrollPane2.setBorder(null);
    DescriptionLabel.setFont(new java.awt.Font("Dialog", 1, 16));
    DescriptionLabel.setLabelFor(DescriptionTextPane);
    DescriptionLabel.setText("Description of Events");
    RecordInfoLabel.setFont(new java.awt.Font("Dialog", 3, 18));
    RecordInfoLabel.setText("Record Information");
    AuthorLabel.setLabelFor(AuthorTextField);
    AuthorLabel.setText("Author of Record:");
    AuthorTextField.setHorizontalAlignment(SwingConstants.LEFT);
    DateLabel.setLabelFor(DateTextField);
    DateLabel.setText("Date Created:");
    NameLabel.setLabelFor(NameTextField);
    NameLabel.setText("Official Virus Name:");
    FileNameLabel.setLabelFor(FileNameTextField);
    FileNameLabel.setText("File Name:");
    jLabel1.setText("(Click to View)");
    AddButton.setText("Add Record");
    AddButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        AddButton_actionPerformed(e);
      }
    });
    RemoveButton.setText("Remove Record");
    RemoveButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        RemoveButton_actionPerformed(e);
      }
    });
    AddLabel.setLabelFor(AddButton);
    AddLabel.setText("Click to Add Information as a New Record");
    RemoveLabel.setLabelFor(RemoveButton);
    RemoveLabel.setText("Click to Remove Current Record");
    contentPane.add(jPanel1,        new XYConstraints(3, 8, 239, 691));
    jPanel1.add(jScrollPane1,    new XYConstraints(7, 45, 221, 633));
    jPanel1.add(jLabel1,      new XYConstraints(66, 19, 100, 24));
    jPanel1.add(listLabel, new XYConstraints(17, 0, 205, 31));
    contentPane.add(jPanel2,  new XYConstraints(250, 10, 454, 688));
    jScrollPane1.getViewport().add(RecordList, null);
    jPanel2.add(NameTextField,   new XYConstraints(135, 89, 286, 26));
    jPanel2.add(FileNameTextField, new XYConstraints(136, 134, 288, 27));
    jPanel2.add(AuthorTextField, new XYConstraints(137, 179, 210, 29));
    jPanel2.add(DateLabel,  new XYConstraints(11, 228, 103, 27));
    jPanel2.add(DateTextField, new XYConstraints(137, 234, 131, 26));
    jPanel2.add(DescriptionLabel,   new XYConstraints(132, 267, 176, 43));
    jPanel2.add(jPanel3,  new XYConstraints(3, 301, -1, 332));
    jPanel3.add(jScrollPane2,   new XYConstraints(3, 15, 439, 272));
    jScrollPane2.getViewport().add(DescriptionTextPane, null);
    jPanel2.add(AddButton, new XYConstraints(47, 634, 142, -1));
    jPanel2.add(RemoveButton, new XYConstraints(281, 637, 129, 26));
    jPanel2.add(NameLabel, new XYConstraints(10, 89, 122, 27));
    jPanel2.add(AuthorLabel, new XYConstraints(11, 180, 110, 29));
    jPanel2.add(FileNameLabel, new XYConstraints(11, 130, 104, 29));
    jPanel2.add(RecordInfoLabel,  new XYConstraints(112, 11, 219, 51));
    jPanel3.add(AddLabel,     new XYConstraints(12, 298, 243, 34));
    jPanel3.add(RemoveLabel,  new XYConstraints(251, 302, 195, 29));

    RecordList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    RecordList.addListSelectionListener(new ListSelectionListener (){
      public void valueChanged(ListSelectionEvent e){
      RecordSelection(e);
    }
    });
//////////////////////////////////////////////////////////////////////
    VDataBase = new VirusDatabase("virusDatabase.txt");
    VDataBase.loadDB();
    Event EventObject = new Event();
    for(int i = 0; i < VDataBase.getEventCount(); i++)
    {
      EventObject = VDataBase.getEventAt(i);
      listModel.addElement(EventObject.getVirusName());
    }
  }
//////////////////////////////////////////////////////////////////////////
  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      System.exit(0);
    }
  }


  void AddButton_actionPerformed(ActionEvent e) {
    String AddName = NameTextField.getText();
    String AddDate = DateTextField.getText();
    String AddFileName = FileNameTextField.getText();
    String AddAuthor = AuthorTextField.getText();
    String AddDescription = DescriptionTextPane.getText();
    Vector AddVector = new Vector();
    AddVector.add(AddName);
    AddVector.add(AddFileName);
    AddVector.add(AddAuthor);
    AddVector.add(AddDate);
    AddVector.add(AddDescription);
    //Call Add to database method passing in AddVector
    VDataBase.addEvent(AddName,AddFileName,AddAuthor,AddDate,AddDescription);
    listModel.removeAllElements();
    RecordList.updateUI();
    Event EventObject = new Event();

    for(int i = 0; i < VDataBase.getEventCount(); i++)
    {
      EventObject = VDataBase.getEventAt(i);
      listModel.addElement(EventObject.getVirusName());
    }
    NameTextField.setText("");
    DateTextField.setText("");
    FileNameTextField.setText("");
    AuthorTextField.setText("");
    DescriptionTextPane.setText("");

  }

  void RemoveButton_actionPerformed(ActionEvent e) {

    //Call Remove from database method passing in RemoveName
    VDataBase.removeEventAt(selectIndex);
    listModel.removeAllElements();
    RecordList.updateUI();
    Event EventObject = new Event();

    for(int i = 0; i < VDataBase.getEventCount(); i++)
    {
      EventObject = VDataBase.getEventAt(i);
      listModel.addElement(EventObject.getVirusName());
    }

    NameTextField.setText("");
    DateTextField.setText("");
    FileNameTextField.setText("");
    AuthorTextField.setText("");
    DescriptionTextPane.setText("");
  }


  void RecordSelection( ListSelectionEvent e){
    //access record e and display information
        if (e.getValueIsAdjusting())
        return;

    JList theList = (JList)e.getSource();
    int index = theList.getSelectedIndex();
    Event displayEvent = VDataBase.getEventAt(index);
    NameTextField.setText(displayEvent.getVirusName());
    DateTextField.setText(displayEvent.getDate());
    FileNameTextField.setText(displayEvent.getVirusFileName());
    AuthorTextField.setText(displayEvent.getAuthor());
    DescriptionTextPane.setText(displayEvent.getDescription());
    selectIndex = index;

  }


}